/*
 * msgBoxLib v 1.0
 * My web studio - http://site-core.ru
 * Created by ViES
 * Copyright (c) 2014 ViES
 *
 * Released under the MIT License:
 * http://www.opensource.org/licenses/mit-license.php
 */
 
var msgBox = function(config, event) {
if (!event) event = window.event;

//	this.config = config;
	this.msgBoxObj  = {
//default config
		width: '',
		height: '',
		main_class: 'msgBox',
		z_index: 99,
		buttons: {},
		history: [], //try to connect with window.history via array ID
		parent: 'body',
		content: '',
		showOverlay: true,
		
		set_config : function() {
			if (config != null) {
				if (config.width) this.width =  config.width;
			//	if (config.content) this.content =  config.content;
				if (config.height) this.height =  config.height;
				if (config.main_class) this.main_class =  config.main_class;
				if (config.sndClass) this.sndClass =  config.sndClass;
				if (config.z_index) this.z_index = config.z_index;
				if (config.buttons) this.buttons = config.buttons;
				if (config.parent) this.parent = config.parent;
			}
		},
		
		set_styles : function() {
			if (this.sndClass) $(this.msgBox).addClass(this.sndClass);
			if (this.showOverlay) $(this.msgBox).addClass("overlay");
			$(this.msgBox).css("width", this.width);
			$(this.msgBox).css("height", this.height);
			$(this.msgBox).css("z-index", this.z_index);
		},		
		create_button : function(btn_name,btn_class,btn_event) {
				var _this = this;
//				console.log("btn." + button + " = " + btn_name);
				var button = document.createElement("button");
				if (btn_class) button.className = btn_class;
				if (btn_event=='close_msgBox') button.className = 'close_msgBox';
				$(button).html(btn_name);
				if (btn_event){
					$(button).click(function (){
						if (typeof (btn_event)=='function') {
							btn_event(btn_name);
						} else if (btn_event=='close_msgBox') {
							_this.fadeOut_msgBox();
						}
					});
				}
				return button;
		},
		
		init_buttons : function() {
			for (var button in this.buttons) {
				var btn_name = this.buttons[button].btn_name;
				var btn_class = this.buttons[button].btn_class;
				var btn_event = this.buttons[button].btn_event;				
				var btn = this.create_button(btn_name,btn_class,btn_event);
				$(this.wrapper).append(btn);
			}
		},
		closeMsgBox : function() {
			var _this = this;
			$(document).unbind("click", _this);
			this.fadeOut_msgBox();
		},

		fadeIn_msgBox : function() {
			var _this = this;
			$(this.msgBox)
			.fadeIn("slow", function() {
				$(document).bind('click.closeMsgBox', function(){
					_this.fadeOut_msgBox();
				});

			//	console.log($._data( $(document)[0], 'events' ).click); //list of events
			//	$(document).on('click', function() {
			//		console.log('lol');
			//	});
			//	$.each($(document).data('events'), function(i, e) {
			//		console.log(i, e);
			//	});
				
			}).find(this.content).click(function(e) {
				e.stopPropagation();
			}).trigger('fadeIn_msgBox');
		},
		
		fadeOut_msgBox : function() {
			$(document).unbind("click.closeMsgBox");
		//	console.log($._data( $(document)[0], 'events' ).click); //list of events

			var _this = this;
			$(_this.msgBox).fadeOut("fast",function(){
				if(event)
					_this.bind_event();
				if(_this.history.length)
					_this.change_content(_this.history[0]); // change content to origin
			}).trigger('fadeOut_msgBox');
		},
		
		bind_event : function() {
			var _this = this;
			if (this.orig_event) {
				 $(event.target).attr( "onclick", this.orig_event);
			} else {
				$(this.eTarget).click(function(){ //alternative, bagging
					_this.fadeIn_msgBox();
				//	_this.orig_event;
				});
			}
		},
		
		remove_event : function() {
			if(typeof event !== "undefined") {
				this.eTarget = event.currentTarget;
				this.targetClass = '.'+$(this.eTarget).attr('class');


				if ($(event.target).attr("onclick")) { //eTarget не используется
					this.orig_event = $(event.target).attr("onclick");
					$(event.target).attr("onclick", null); // remove attribute onclick
				} else {
					if ($(this.targetClass).length)
						this.eTarget = this.targetClass;

					$(this.eTarget).unbind("click"); // unbind event

				}
			}
			//problem here solved
		},
		
	//	check_content : function() {},
		
		change_content : function(new_content) { //reload_content
			if($.inArray($(this.content).contents(), this.history) === -1)
				this.history.push($(this.content).contents().clone(true));
				console.log(this.history);
			$(this.content).contents().fadeOut("fast").promise().done(
				function() {
					$(this).parent().html(new_content).hide().fadeIn("fast").trigger('change_content');
				});
		},
		
		createMsgBox : function(){
			// prevent href transition - only one time
			//	event.preventDefault ? event.preventDefault() : (event.returnValue=false);
			var _this = this;
			this.set_config();
			this.msgBox = $("<div>").addClass(this.main_class);
			this.wrapper = $("<div>").addClass("wrapper");
			this.set_styles();
			this.content = $("<div>")
				.addClass("msgBox_content")
				.html(config.content);
			$(this.wrapper).append(this.content);
			$(this.msgBox).append(this.wrapper);

			
		//	$(this.msgBox).html(config.content);
			this.buttons.closeBtn = {
				btn_name:"&times;", btn_event:'close_msgBox'
			};
			if ( !jQuery.isEmptyObject(this.buttons) )
				this.init_buttons();
			this.remove_event();
			
			$(this.msgBox)
				.hide()
				.appendTo(this.parent);
			
			this.fadeIn_msgBox();
			return this;
		}
		
	};
	return this.msgBoxObj.createMsgBox();	
};
